include "ZeroPage.inc"
include "VVram.inc"
include "Chars.inc"

ext VVram_
ext BaseX_, BaseY_, Map_

MapStep equ 8

pMapRow equ ZW0
pMapByte equ ZW1
pVVram equ ZW2
mask equ ZB0
yCount equ ZB1
xCount equ ZB2

; ptr<byte> VVramPtr(byte x, byte y);
dseg
VVramPtr_@Param1: public VVramPtr_@Param1
VVramPtr_y:
    defs 1
cseg
VVramPtr_: public	VVramPtr_
	psha | pshb
        staa <ZB0
        ldaa #VVramWidth
        ldab VVramPtr_y
        mul
        addb <ZB0
        adca #0
        addb #low VVram_
        adca #high VVram_
        xgdx
	pulb | pula
rts


; void MapToVVram();
cseg
MapToVVram_: public MapToVVram_
	psha | pshb
                                _deb: public _deb
        ldab BaseY_
        clra
        asld ; *2
        asld ; *4
        asld ; *8
        addd #Map_
        xgdx
        ldab BaseX_
        pshb
            lsrb | lsrb | lsrb
            abx
            stx <pMapRow
        pulb
        ldaa #1
        andb #7
        do | while ne
            asla
            decb
        wend
        staa <mask
        ldx #VVram_ | stx <pVVram
        ldaa #VVramHeight | staa <yCount
        do
            ldx <pMapRow | stx <pMapByte
            ldaa #VVramWidth | staa <xCount
            do
                ldx <pMapByte
                ldab 0,x
                andb <mask
                if ne
                    ldaa #Char_Wall
                else
                    ldaa #Char_Space
                endif
                ldx <pVVram
                staa 0,x | inx
                stx <pVVram
                asl <mask
                if eq
                    ldaa #1 | staa <mask
                    ldx <pMapByte | inx | stx <pMapByte
                endif
                dec <xCount
            while ne | wend
            ldd <pMapRow | addd #MapStep | std <pMapRow
            dec <yCount
        while ne | wend
	pulb | pula
rts
